﻿// CodeGear C++Builder
// Copyright (c) 1995, 2015 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'ZylIdleTimer.pas' rev: 30.00 (Windows)

#ifndef ZylidletimerHPP
#define ZylidletimerHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member 
#pragma pack(push,8)
#include <System.hpp>
#include <SysInit.hpp>
#include <System.SysUtils.hpp>
#include <System.Classes.hpp>
#include <Winapi.Windows.hpp>
#include <System.Math.hpp>
#include <Winapi.Messages.hpp>
#include <Vcl.Dialogs.hpp>
#include <Vcl.Forms.hpp>

//-- user supplied -----------------------------------------------------------

namespace Zylidletimer
{
//-- forward type declarations -----------------------------------------------
class DELPHICLASS TCustomTimer;
class DELPHICLASS TZylIdleTimer;
//-- type declarations -------------------------------------------------------
enum DECLSPEC_DENUM TIdleTimerKind : unsigned char { itApplication, itSystem };

class PASCALIMPLEMENTATION TCustomTimer : public System::Classes::TComponent
{
	typedef System::Classes::TComponent inherited;
	
private:
	unsigned FInterval;
	HWND FWindowHandle;
	System::Classes::TNotifyEvent FOnTimer;
	void __fastcall UpdateTimer(void);
	void __fastcall SetInterval(unsigned Value);
	void __fastcall SetOnTimer(System::Classes::TNotifyEvent Value);
	void __fastcall WndProc(Winapi::Messages::TMessage &Msg);
	
protected:
	bool FEnabled;
	__property unsigned Interval = {read=FInterval, write=SetInterval, default=5000};
	__property System::Classes::TNotifyEvent OnTimer = {read=FOnTimer, write=SetOnTimer};
	DYNAMIC void __fastcall Timer(void);
	virtual void __fastcall SetEnabled(bool Value);
	
__published:
	__property bool Enabled = {read=FEnabled, write=SetEnabled, default=1};
	
public:
	__fastcall virtual TCustomTimer(System::Classes::TComponent* AOwner);
	__fastcall virtual ~TCustomTimer(void);
};


class PASCALIMPLEMENTATION TZylIdleTimer : public TCustomTimer
{
	typedef TCustomTimer inherited;
	
private:
	unsigned FInterval;
	unsigned FWarningInterval;
	System::TDateTime FApplicationIdleStartDateTime;
	System::TDateTime FSystemIdleStartDateTime;
	bool FApplicationIdleWasFired;
	bool FSystemIdleWasFired;
	bool FWarningWasFired;
	TIdleTimerKind FKind;
	System::Classes::TNotifyEvent FOnIdle;
	System::Classes::TNotifyEvent FOnWarning;
	System::Classes::TNotifyEvent FOnResume;
	double FVersion;
	System::AnsiString FLockKey;
	System::AnsiString FUnlockKey;
	bool __fastcall GetLastInputInfoA(Winapi::Windows::PLastInputInfo plii);
	void __fastcall SetKind(TIdleTimerKind Value);
	double __fastcall GetIntervalInMinutes(void);
	double __fastcall GetIntervalInSeconds(void);
	void __fastcall SetIntervalInMinutes(const double Value);
	void __fastcall SetIntervalInSeconds(const double Value);
	void __fastcall SetWarningInterval(const unsigned Value);
	double __fastcall GetWarningIntervalInMinutes(void);
	double __fastcall GetWarningIntervalInSeconds(void);
	void __fastcall SetWarningIntervalInMinutes(const double Value);
	void __fastcall SetWarningIntervalInSeconds(const double Value);
	bool __fastcall RunningInTheIDE(void);
	int __fastcall GetChecksum(const System::AnsiString str);
	System::AnsiString __fastcall DecryptString(const System::AnsiString str);
	bool __fastcall IsRegistered(void);
	void __fastcall CheckRegistered(void);
	
protected:
	void __fastcall DoTimer(System::TObject* Sender);
	void __fastcall SetApplicationIdleStartDateTime(tagMSG &Msg, bool &Handled);
	virtual void __fastcall SetEnabled(bool Value);
	HIDESBASE void __fastcall SetInterval(unsigned Value);
	
public:
	__property double Version = {read=FVersion};
	__property System::AnsiString UnlockKey = {read=FUnlockKey, write=FUnlockKey};
	__fastcall virtual TZylIdleTimer(System::Classes::TComponent* AOwner);
	__fastcall virtual ~TZylIdleTimer(void);
	unsigned __fastcall GetRelativeSystemIdleTime(void);
	unsigned __fastcall GetSystemIdleTime(void);
	unsigned __fastcall GetApplicationIdleTime(void);
	void __fastcall ResetApplicationIdleTime(void);
	void __fastcall ResetSystemIdleTime(void);
	
__published:
	__property unsigned Interval = {read=FInterval, write=SetInterval, default=5000};
	__property unsigned WarningInterval = {read=FWarningInterval, write=SetWarningInterval, default=4000};
	__property double IntervalInMinutes = {read=GetIntervalInMinutes, write=SetIntervalInMinutes};
	__property double IntervalInSeconds = {read=GetIntervalInSeconds, write=SetIntervalInSeconds};
	__property double WarningIntervalInMinutes = {read=GetWarningIntervalInMinutes, write=SetWarningIntervalInMinutes};
	__property double WarningIntervalInSeconds = {read=GetWarningIntervalInSeconds, write=SetWarningIntervalInSeconds};
	__property TIdleTimerKind Kind = {read=FKind, write=SetKind, nodefault};
	__property System::Classes::TNotifyEvent OnIdle = {read=FOnIdle, write=FOnIdle};
	__property System::Classes::TNotifyEvent OnWarning = {read=FOnWarning, write=FOnWarning};
	__property System::Classes::TNotifyEvent OnResume = {read=FOnResume, write=FOnResume};
};


//-- var, const, procedure ---------------------------------------------------
static const System::Int8 Precision = System::Int8(0xf);
extern DELPHI_PACKAGE void __fastcall Register(void);
}	/* namespace Zylidletimer */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_ZYLIDLETIMER)
using namespace Zylidletimer;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// ZylidletimerHPP
